/* bresultf.c Stefan Spaennare Feb 98 */

/*****************************************************************************/
/*                                                                           */
/* Notice:                                                                   */
/* =======                                                                   */
/*                                                                           */
/* I make no warranties that this program is (1) free of error, (2) con-     */
/* sistent with any standard merchantability, or (3) meeting the require-    */
/* ments of a particular application.  This software shall not, partly or    */
/* as a whole, participate in a process, whose outcome can result in injury  */
/* to a person or loss of property. It is solely designed for analytical     */
/* work.  Permission to use, copy, and distribute is hereby granted without  */
/* fee, providing that the header above including this notice appears in     */
/* all copies.                                                               */
/*                                                                           */
/*                                                         Stefan Spaennare  */
/*                                                                           */
/*****************************************************************************/


#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <time.h>

void getrow(infile,ss)
FILE *infile;
char *ss;
{
   int j;
   char c;

   if ((c = getc(infile)) != EOF) {
      ss[0]=c;
      j=1;
      if (c != '\n') {
         while ((c = getc(infile)) != '\n') {
            ss[j]=c;
            j++;
         } /* while */
      } /* if */
      ss[j]='\0';
   } /* if */

} /* getrow */


int main(argc,argv)
int argc;
char *argv[];

{
   
   FILE *infile;

   int i,j,n;

   double meani,meanf,t1,t2,t3,t4,t5,t6,t7;
   double sum,temp,base;

   char c;
   char ss[257];
   char ss2[21];
   char ss3[21];
   char ss4[21];
   char ss5[21];
   char ss6[21];

   double vf[9];
   double vrf[9];


   if (argc < 2) {
      printf("Usage: %s timesffile\n",argv[0]);
      exit(0);
   } /* if */
   

   if ((infile = fopen(argv[1],"r")) == NULL) {
      printf("File not found.\n");
      exit(0);
   } /* if */

   fscanf(infile,"%s %lf",ss2,&vf[1]);

   for (i=1; i<=3; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%s %lf",ss2,&vf[2]);

   for (i=1; i<=4; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%lf",&vf[3]);

   fscanf(infile,"%lf %lf %lf %lf %lf %lf %lf %lf",
          &t1,&t2,&t3,&t4,&t5,&t6,&t7,&vf[4]);

   for (i=1; i<=1; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%lf",&vf[5]);

   for (i=1; i<=55; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%s %s %lf",ss2,ss3,&vf[6]);

   for (i=1; i<=41; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%s %s %lf",ss2,ss3,&vf[7]);

   for (i=1; i<=15; i++) {
      getrow(infile,ss);
   } /* for i */

   fscanf(infile,"%s %s %lf",ss2,ss3,&vf[8]);



   vrf[1]=1.0;
   vrf[2]=1.0;
   vrf[3]=1.0;
   vrf[4]=1.0;
   vrf[5]=1.0;
   vrf[6]=1.0;
   vrf[7]=1.0;
   vrf[8]=1.0;


   meanf=1.0;
   sum=0.0;

   for (i=1; i<=8; i++) {
      temp=vf[i]/vrf[i];
      sum=sum+temp;
      meanf=meanf*temp;
   } /* for i */

   meanf=exp(log(meanf)/8.0);

   base=1000.0;

   printf("\n");
   printf("SSBENCH: Floating Point CPU Benchmark Result\n");
   printf("============================================\n");

   printf("\n");
   printf("   Program        CPU-time       SIfp\n");
   printf("--------------------------------------\n");
   printf("1: Mand:        %9.2f s %9.2f\n",vf[1],base/vf[1]);
   printf("2: Newton:      %9.2f s %9.2f\n",vf[2],base/vf[2]);
   printf("3: Findsmbf:    %9.2f s %9.2f\n",vf[3],base/vf[3]);
   printf("4: Polyfitf:    %9.2f s %9.2f\n",vf[4],base/vf[4]);
   printf("5: Plotss:      %9.2f s %9.2f\n",vf[5],base/vf[5]);
   printf("6: Sspienr pi:  %9.2f s %9.2f\n",vf[6],base/vf[6]);
   printf("7: Sspienr gs:  %9.2f s %9.2f\n",vf[7],base/vf[7]);
   printf("8: Ssef:        %9.2f s %9.2f\n",vf[8],base/vf[8]);
   printf("--------------------------------------\n");

   printf("FP geom mean:   %9.2f s %9.2f\n",meanf,base/meanf);

   printf("--------------------------------------\n");
   printf("Time total:     %9.2f s\n",sum);
   printf("--------------------------------------\n");
   printf("\n");


} /* End */
