/******************************************************/
/*                                                    */
/* This program is free to copy !                     */
/*                                                    */
/* Program: primes2.c                                 */
/*                                                    */
/* This program calculates the number of prime        */
/* numbers below n.                                   */
/*                                                    */
/* Author: Stefan Spaennare                           */
/* Email:  stefans@astro.lu.se                        */
/*                                                    */
/* Memory requirement: No arrays                      */
/*                                                    */
/* Benchmarking:                                      */
/*                                                    */
/* n = 1000000 = 10^6                                 */
/*                                                    */
/* Computer:       CPU-time (s):      Compilation:    */
/*                                                    */
/* HP 735 99 MHz       61.70            cc  +O3       */
/* Pentium 150 MHz     25.93            gcc -O4       */
/*                                                    */
/******************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

double timetic=(double)(CLOCKS_PER_SEC);

int main(argc,argv)
int argc;
char *argv[];
{

   int i,j,k,i2,n,p2,m,l,sum;

   clock_t time1,timediff;

   double ftime;

   if (argc < 2) {
      printf("Usage: %s ni\n",argv[0]);
      exit(0);
   } /* if */

   n=atoi(argv[1]);

   time1=clock();

   i=2;
/*   printf("%8d",i); */

   sum=1;
   m=1;

   for (i=3; i<=n; i=i+2) {
      i2=(int)(sqrt((double)(i)))+1;
      k=2;
      while ((k<i2) && ((i % k) != 0)) {
	 k++;
      } /* while */
      if (k==i2) {
/*
	 printf("%8d",i);
	 m++;
	 if (((m) % 8) == 0) {
	   printf("\n");
	 }
*/
         sum++;
      } /* if */
   } /* for i */

   timediff=clock()-time1;

   printf("%12d\n\n",sum);

   ftime=(double)(timediff)/timetic;

   printf("%12.2f\n",ftime);


} /* End */
